# frozen_string_literal: true

require 'aws-sdk-dynamodb'

module RServiceBus2
  # AppResourceAWSDynamoDb
  class AppResourceAWSDynamoDb < AppResource
    def connect(uri)
      host_name = uri.host
      url_port = uri.port.nil? ? '' : ":#{uri.port}"

      region = nil
      unless uri.query.nil?
        parts = CGI.parse(uri.query)
        region = parts['region'][0] unless parts['region'].nil?
      end

      if region.nil?
        Aws::DynamoDB::Client.new(endpoint: "http://#{host_name}#{url_port}")
      else
        Aws::DynamoDB::Client.new(endpoint: "http://#{host_name}#{url_port}", region: region)
      end
    end

    def finished
      RServiceBus2.rlog "#{self.class.name}. Finished"
    end
  end
end
