# frozen_string_literal: true

require 'aws-sdk-s3'

module RServiceBus2
  # AppResourceAWSDynamoDb
  class AppResourceAWSS3 < AppResource
    def connect(uri)
      host_name = uri.host
      url_port = uri.port.nil? ? '' : ":#{uri.port}"

      region = nil
      unless uri.query.nil?
        parts = CGI.parse(uri.query)
        region = parts['region'][0] unless parts['region'].nil?
      end

      if region.nil?
        Aws::S3::Client.new(endpoint: "http://#{host_name}#{url_port}")
      else
        puts "region: #{region}"
        Aws::S3::Client.new(endpoint: "http://#{host_name}#{url_port}", region: region)
      end

      #Aws::S3::Client.new(region: region)
    end

    def finished
      RServiceBus2.rlog "#{self.class.name}. Finished"
    end
  end
end
